# GameCube Backup Manager

**GCBM (GameCube Backup Manager)** is a program to work with FAT32, exFAT and NTFS drives *(NTFS devices only work as a backup, they don't work on Nintendont)* allowing you to correctly convert ISO files for use on Nintendont.

Visit GameTDB, a collaborative game database for anyone to contribute and anyone to use in any game-related project. Just click on the link below (image):
* [![GameTDB](GameTDB-100.png)](https://www.gametdb.com/)

If you liked GameCube Backup Manager, feel free to donate any amount via PayPal. Just click on the link below (image):
* [![paypal](donate.gif)](https://www.paypal.com/donate/?hosted_button_id=MP4WGLJHAP8H2)

#### THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

### Download:
All Releases: https://github.com/AxionDrak/GameCube-Backup-Manager/releases

### Features:

+ Individual or batch file transfer (v2.5.0.0 or higher)
+ Reads ISO / GCM / NKit (ISO only - not GCZ)
+ Writes ISO
+ Execution of multiple instances of the program.
+ Load the 'wiitdb.xml' file in the 'Database' tab and preview its contents (A good option for discovering new games!)
+ Automatic update system.
+ Proxy system.
+ Cover transfer (WiiFlow, WiiFlow Lite, WiiFlow Fusion).
+ Cover transfer (USB Loader GX, USB Loader GX Tab MOD).
+ Transferring games with the correct nomenclature (Game Name+ID or ID only).
***Available in “Install Game (1:1)” mode using the commercial name via ‘wiitdb.xml’. The “Install Game (Scrub)” mode uses the internal nomenclature provided by the developer, that is, it does not use ‘wiitdb.xml’.***
+ Game transfer via XCopy (1:1 copies - Standard).
+ Game transfer via Scrub (GCReEx and DiscEx).
+ Deleting game files (Source and Destination).
+ Display of game information (region, publisher, genre, etc). ***File ‘wiitdb.xml’ required.***
+ ESRB ratings display. ***File ‘wiitdb.xml’ required.***
+ WiiTDB support for naming. ***File ‘wiitdb.xml’ required.***
+ Improved GameCube ISO detection in 'internal' mode (Standard).
+ Improved GameCube ISO detection in 'external' mode (GameTDB). ***The 'wiitdb.xml' file is required.***
+ Global download of Disc and 3D covers (for all games listed!).
+ Individual download of covers for the selected game (Disc and 3D).
+ Download the file 'wiitdb.xml' (GameTDB).
+ MD5 hash Calculation (manual option).
+ SHA-1 Hash Calculation (manual option).
+ Automatic creation of 'games' folder (if it doesn't exist).
+ LOG system.
+ Multiple languages supported:
  + Portuguese (Brazil)
  + English (United States)
  + Spanish (Spain)
  + Korean (Korea)
+ More polished and functional graphical interface (UI).

### Requirements
* .NET Framework 4.6 (version 2.5.x.x or lower)
* .NET Framework 4.8 (version 2.6.x.x or higher)
* Microsoft Windows 64-bit (32-bit not supported!)

### Screenshots

![main](imgs/gcbm001.png)
![main](imgs/gcbm002.png)
![main](imgs/gcbm003.png)
![main](imgs/gcbm004.png)

### Notes

+ The Wii and Wii U SD card slot is known to be slow. If you're using an SD card and are having performance issues, consider either using a USB SD reader or a USB hard drive (Highly recommended!).
+ USB flash drives are known to be problematic.
+ Nintendont runs best with storage devices formatted with 32 KB clusters. Use either FAT32 or exFAT (FAT32 highly recommended!). 

# README Translations:
* [Japanese](README_JP.md)
* [Ryukyuan](README_RYU.md)
